
(let (( rnd 5.1234567890123))
  (defun random (&aux seed)        ; 0 - 1
    (when seed (setf rnd seed))
    (when (< rnd 1.1) (setf rnd (+ rnd 6.123456789123)))
    (setf rnd  (sqrt (rem (* 1000 rnd))))
    (rem (* 1000  rnd))
 )
)


(defun  rnd ( n ) ; 0 - n-1
 (1+ (round (* n (random) )))  
)



(defun rround (r) (round (+ .5 r]





(defvar xs )
(defvar ys )
(defvar xe )
(defvar ye )
(defvar rxs)
(defvar rys)
(defvar rxe)
(defvar rye)

(defun animate-hip (dxs dys dxe dye)
 (while ((and
           (> xs -1)
           (< xs *scrnx*)   
           (> xe -1)
           (< xe *scrnx*)           
           (> ys -1)
           (< ys *scrny*)   
           (> ye -1)
           (< ye *scrny*)            
       ))
   (gmoveto xs ys)
   (glineto xe ye)
   (setf xs (+ xs dxs)  
         xe (+ xe dxe)
         ys (+ ys dys)
         ye (+ ye dye)
   )
 )
)






(defun do-hip (&aux (sxs 1) (sxe -1) (sys -1) (sye 1))
 (setf xs 100 ys 100 xe 200 ye 200)
 (dotimes (i 250)
  (gpencolor (+ (rnd 256) (* 256 (rnd 256)) (* 65536 (rnd 256))))    
  (animate-hip (* sxs (rnd 5)) (* sys (rnd 5)) (* sxe (rnd 5)) (* sye (rnd 5))) 
  (unless (> xs -1     ) (setf xs 0            sxs (* -1 sxs)))
  (unless (< xs *scrnx*) (setf xs (1- *scrnx*) sxs (* -1 sxs)))
  (unless (> xe -1     ) (setf xe 0            sxe (* -1 sxe)))
  (unless (< xe *scrnx*) (setf xe (1- *scrnx*) sxe (* -1 sxe)))
  (unless (> ys -1     ) (setf ys 0            sys (* -1 sys)))
  (unless (< ys *scrny*) (setf ys (1- *scrny*) sys (* -1 sys)))
  (unless (> ye -1     ) (setf ye 0            sye (* -1 sye)))
  (unless (< ye *scrny*) (setf ye (1- *scrny*) sye (* -1 sye)))
 )
)

;(do-hip)
 
  
  


(defun animate-remove-hip (dxs dys dxe dye rdxs rdys rdxe rdye &aux (f1 t) (f2 t))
 (while ((or f1 f2))
   (when (setf f1 (and
           (> xs -1)
           (< xs *scrnx*)   
           (> xe -1)
           (< xe *scrnx*)           
           (> ys -1)
           (< ys *scrny*)   
           (> ye -1)
           (< ye *scrny*)            
           CanPrn
         ))
     (gpencolor (setf Color (+ Color Colorstep)))    
     (gmoveto xs ys)
     (glineto xe ye)
     (setf xs (+ xs dxs)  
           xe (+ xe dxe)
           ys (+ ys dys)
           ye (+ ye dye)
     )
   )
   (when (setf f2 (and
           (> rxs -1)
           (< rxs *scrnx*)   
           (> rxe -1)
           (< rxe *scrnx*)           
           (> rys -1)
           (< rys *scrny*)   
           (> rye -1)
           (< rye *scrny*)            
           CanDel
         ))
     (gpencolor 0)
     (gmoveto rxs rys)
     (glineto rxe rye)
     (setf rxs (+ rxs rdxs)  
           rxe (+ rxe rdxe)
           rys (+ rys rdys)
           rye (+ rye rdye)
     )
   )
 )
 (cond					;PRN DEL
   ((not (or f1 f2))			;nil nil
    (setf CanDel t   CanPrn t)
   )
   ((and f2 (not f1))			;nil  t
    (setf CanDel t   CanPrn nil)
   )
   ((and f1 (not f2))			; t  nil
    (setf CanDel nil CanPrn t)
   )
   (t (print "Internal Error"))
 ) 
)  
   
(defun do-ar-hip (&optional (fact 5)
                  &aux (sxs  -1)(sxe  1) (sys  1) (sye  1)
                       (dxs  -1)(dys  1) (dxe  1) (dye  1) 
                       (rdxs 0)(rdys 0) (rdxe 0) (rdye 0) 
                  )  
 (setf *scrnx* (gmode 2))
(setf *scrny* (car(cdr *scrnx*)))
(setf *scrnx* (car *scrnx*))
                
 (setf xs  100   ys  100 xe  200 ye  200)
 (setf rxs 100  rys 100  rxe 200 rye 200)
 (setf CanPrn t CanDel nil)
 (setf Startf t)
 (setf Color 0 Colorstep (+ (* 65536 8) (* 256 64) 16))
 (dotimes (i 250)
 
  (animate-remove-hip dxs dys dxe dye rdxs rdys rdxe rdye) 
  (when CanDel
  (when Startf            (setf Startf nil       rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (> rxs -1     ) (setf rxs 0            rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (< rxs *scrnx*) (setf rxs (1- *scrnx*) rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (> rxe -1     ) (setf rxe 0            rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (< rxe *scrnx*) (setf rxe (1- *scrnx*) rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (> rys -1     ) (setf rys 0            rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (< rys *scrny*) (setf rys (1- *scrny*) rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (> rye -1     ) (setf rye 0            rdxs dxs rdys dys rdxe dxe rdye dye ))
  (unless (< rye *scrny*) (setf rye (1- *scrny*) rdxs dxs rdys dys rdxe dxe rdye dye ))
  )
  (when CanPrn
  (unless (> xs -1     ) (setf xs 0            sxs (* -1 sxs) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (< xs *scrnx*) (setf xs (1- *scrnx*) sxs (* -1 sxs) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (> xe -1     ) (setf xe 0            sxe (* -1 sxe) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (< xe *scrnx*) (setf xe (1- *scrnx*) sxe (* -1 sxe) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (> ys -1     ) (setf ys 0            sys (* -1 sys) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (< ys *scrny*) (setf ys (1- *scrny*) sys (* -1 sys) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (> ye -1     ) (setf ye 0            sye (* -1 sye) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  (unless (< ye *scrny*) (setf ye (1- *scrny*) sye (* -1 sye) dxs (* sxs (rnd fact)) dxe (* sxe (rnd fact)) dys (* sys (rnd fact)) dye (* sye (rnd fact)) ))
  )
 )
)

(print "Demo grafico caricato \n")
(print "digita (do-ar-hip) \n")
(print "NB: Con windows attiva prima l'opzione SELF PREEMPTIVE\n nel menu OPTIONS\n")


;(do-ar-hip)
 
  
   